import * as fs from 'fs';
import { InvoiceOldTempalte } from '../templates/invoice-old.template';
const PdfPrinter = require('pdfmake');

export function PdfMaker(transaction) {
  var fonts = {
    Courier: {
      normal: 'Courier',
      bold: 'Courier-Bold',
      italics: 'Courier-Oblique',
      bolditalics: 'Courier-BoldOblique',
    },
    Helvetica: {
      normal: 'Helvetica',
      bold: 'Helvetica-Bold',
      italics: 'Helvetica-Oblique',
      bolditalics: 'Helvetica-BoldOblique',
    },
    Times: {
      normal: 'Times-Roman',
      bold: 'Times-Bold',
      italics: 'Times-Italic',
      bolditalics: 'Times-BoldItalic',
    },
    Symbol: {
      normal: 'Symbol',
    },
    ZapfDingbats: {
      normal: 'ZapfDingbats',
    },
  };

  var printer = new PdfPrinter(fonts);

  var docDefinition = InvoiceOldTempalte(transaction);

  var pdfDoc = printer.createPdfKitDocument(docDefinition);
  pdfDoc.pipe(
    fs.createWriteStream(
      `uploads/invoice/${transaction.invoice_code.split('/').join('-')}.pdf`,
    ),
  );
  pdfDoc.end();
}
