export function InvoiceOldTempalte(transaction) {
  return {
    content: [
      {
        columns: [
          [
            {
              text: 'Invoice',
              color: '#333333',
              width: '*',
              fontSize: 28,
              bold: true,
              alignment: 'left',
              margin: [0, 0, 0, 15],
            },
            {
              stack: mappingHeader(transaction),
            },
          ],
          [
            {
              text: 'Customer Detail',
              color: '#aaaaab',
              bold: true,
              fontSize: 14,
              alignment: 'right',
              margin: [0, 20, 0, 5],
            },
            {
              stack: [
                {
                  columns: [
                    {
                      text: 'Name',
                      color: '#aaaaab',
                      bold: true,
                      width: '*',
                      fontSize: 12,
                      alignment: 'right',
                    },
                    {
                      text: transaction.customer_name ?? 'Customer',
                      bold: true,
                      color: '#333333',
                      fontSize: 12,
                      alignment: 'right',
                      width: 100,
                    },
                  ],
                },
                {
                  columns: [
                    {
                      text: 'Email',
                      color: '#aaaaab',
                      bold: true,
                      width: '*',
                      fontSize: 12,
                      alignment: 'right',
                    },
                    {
                      text: transaction.customer_email ?? '-',
                      bold: true,
                      color: '#333333',
                      fontSize: 12,
                      alignment: 'right',
                      width: 100,
                    },
                  ],
                },
                {
                  columns: [
                    {
                      text: 'Phone',
                      color: '#aaaaab',
                      bold: true,
                      width: '*',
                      fontSize: 12,
                      alignment: 'right',
                    },
                    {
                      text: transaction.customer_phone ?? '-',
                      bold: true,
                      color: '#333333',
                      fontSize: 12,
                      alignment: 'right',
                      width: 100,
                    },
                  ],
                },
              ],
            },
          ],
        ],
      },
      '\n\n',
      {
        layout: {
          defaultBorder: false,
          hLineWidth: function (i, node) {
            return 1;
          },
          vLineWidth: function (i, node) {
            return 1;
          },
          hLineColor: function (i, node) {
            if (i === 1 || i === 0) {
              return '#bfdde8';
            }
            return '#eaeaea';
          },
          vLineColor: function (i, node) {
            return '#eaeaea';
          },
          hLineStyle: function (i, node) {
            // if (i === 0 || i === node.table.body.length) {
            return null;
            //}
          },
          // vLineStyle: function (i, node) { return {dash: { length: 10, space: 4 }}; },
          paddingLeft: function (i, node) {
            return 10;
          },
          paddingRight: function (i, node) {
            return 10;
          },
          paddingTop: function (i, node) {
            return 2;
          },
          paddingBottom: function (i, node) {
            return 2;
          },
          fillColor: function (rowIndex, node, columnIndex) {
            return '#fff';
          },
        },
        table: {
          headerRows: 1,
          widths: ['*', 'auto', 'auto', 100],
          body: mappingItem(transaction.items),
        },
      },
      '\n',
      {
        layout: {
          defaultBorder: false,
          hLineWidth: function (i, node) {
            return null;
          },
          vLineWidth: function (i, node) {
            return 1;
          },
          hLineColor: function (i, node) {
            return i === 0 ? '#000000' : '#eaeaea';
          },
          vLineColor: function (i, node) {
            return '#eaeaea';
          },
          hLineStyle: function (i, node) {
            // if (i === 0 || i === node.table.body.length) {
            return null;
            //}
          },
          // vLineStyle: function (i, node) { return {dash: { length: 10, space: 4 }}; },
          paddingLeft: function (i, node) {
            return 10;
          },
          paddingRight: function (i, node) {
            return 10;
          },
          paddingTop: function (i, node) {
            return 3;
          },
          paddingBottom: function (i, node) {
            return 3;
          },
          fillColor: function (rowIndex, node, columnIndex) {
            return '#fff';
          },
        },
        table: {
          headerRows: 1,
          widths: ['*', 100],
          body: mappingPrice(transaction),
        },
      },
      '\n\n',
      {
        text: 'NOTES',
        style: 'notesTitle',
      },
      {
        text: 'Some notes goes here \n Notes second line',
        style: 'notesText',
      },
    ],
    styles: {
      notesTitle: {
        fontSize: 10,
        bold: true,
        margin: [0, 50, 0, 3],
      },
      notesText: {
        fontSize: 10,
      },
    },
    defaultStyle: {
      columnGap: 20,
      font: 'Times',
    },
  };
}

function mappingHeader(transaction) {
  const result = [
    {
      columns: [
        {
          text: 'Receipt No.',
          color: '#aaaaab',
          bold: true,
          width: '*',
          fontSize: 12,
          alignment: 'left',
        },
        {
          text: transaction.invoice_code,
          bold: true,
          color: '#333333',
          fontSize: 12,
          alignment: 'left',
          width: 100,
        },
      ],
    },
    {
      columns: [
        {
          text: 'Date Issued',
          color: '#aaaaab',
          bold: true,
          width: '*',
          fontSize: 12,
          alignment: 'left',
        },
        {
          text: transaction.invoice_date,
          bold: true,
          color: '#333333',
          fontSize: 12,
          alignment: 'left',
          width: 100,
        },
      ],
    },
    {
      columns: [
        {
          text: 'Status',
          color: '#aaaaab',
          bold: true,
          fontSize: 12,
          alignment: 'left',
          width: '*',
        },
        {
          text: transaction.status,
          bold: true,
          fontSize: 14,
          alignment: 'left',
          color: 'green',
          width: 100,
        },
      ],
    },
  ];

  return result;
}

function mappingPrice(transaction) {
  const result = [];
  const sub_total = [
    {
      text: 'Subtotal',
      border: [false, true, false, true],
      alignment: 'right',
      margin: [0, 5, 0, 5],
    },
    {
      border: [false, true, false, true],
      text: Number(transaction.payment_sub_total).toLocaleString('id-ID', {
        style: 'currency',
        currency: 'IDR',
      }),
      alignment: 'right',
      margin: [0, 5, 0, 5],
    },
  ];
  result.push(sub_total);

  if (Number(transaction.payment_discount_total ?? 0) > 0) {
    const discount = [
      {
        text: 'Discount',
        border: [false, false, false, true],
        alignment: 'right',
        margin: [0, 5, 0, 5],
      },
      {
        text: Number(transaction.payment_discount_total).toLocaleString(
          'id-ID',
          {
            style: 'currency',
            currency: 'IDR',
          },
        ),
        border: [false, false, false, true],
        alignment: 'right',
        margin: [0, 5, 0, 5],
      },
    ];
    result.push(discount);
  }

  const total = [
    {
      text: 'Total',
      bold: true,
      alignment: 'right',
      border: [false, false, false, true],
      margin: [0, 5, 0, 5],
    },
    {
      text: Number(transaction.payment_total).toLocaleString('id-ID', {
        style: 'currency',
        currency: 'IDR',
      }),
      bold: true,
      alignment: 'right',
      border: [false, false, false, true],
      margin: [0, 5, 0, 5],
    },
  ];
  result.push(total);

  return result;
}

function mappingItem(items) {
  const header = [
    {
      text: 'DESCRIPTION',
      alignment: 'center',
      fillColor: '#eaf2f5',
      border: [false, true, false, true],
      margin: [0, 5, 0, 5],
      textTransform: 'uppercase',
    },
    {
      text: 'QTY',
      alignment: 'center',
      fillColor: '#eaf2f5',
      border: [false, true, false, true],
      margin: [0, 5, 0, 5],
      textTransform: 'uppercase',
    },
    {
      text: 'UNIT PRICE',
      alignment: 'center',
      fillColor: '#eaf2f5',
      border: [false, true, false, true],
      margin: [0, 5, 0, 5],
      textTransform: 'uppercase',
    },
    {
      text: 'TOTAL',
      border: [false, true, false, true],
      alignment: 'center',
      fillColor: '#eaf2f5',
      margin: [0, 5, 0, 5],
      textTransform: 'uppercase',
    },
  ];

  const result = [];
  items.forEach((item) => {
    const dataRow = [
      {
        text: item.item_name,
        border: [false, false, false, true],
        margin: [0, 5, 0, 5],
        alignment: 'left',
      },
      {
        text: item.qty,
        border: [false, false, false, true],
        margin: [0, 5, 0, 5],
        alignment: 'center',
      },
      {
        text: Number(item.item_price).toLocaleString('id-ID', {
          style: 'currency',
          currency: 'IDR',
        }),
        border: [false, false, false, true],
        margin: [0, 5, 0, 5],
        alignment: 'right',
      },
      {
        text: Number(item.total_price).toLocaleString('id-ID', {
          style: 'currency',
          currency: 'IDR',
        }),
        border: [false, false, false, true],
        alignment: 'right',
        margin: [0, 5, 0, 5],
      },
    ];
    result.push(dataRow);
  });

  const body = [header, ...result];

  return body;
}
