// playground requires you to assign document definition to a variable called dd

import { TransactionEntity } from 'src/modules/transaction/transaction/domain/entities/transaction.entity';
import {
  mappingFooter,
  mappingHeader,
  mappingItem,
  mappingPrice,
} from './helpers/invoice-mapping.helper';

export function InvoiceOldTempalte(transaction: TransactionEntity) {
  return {
    content: [
      {
        alignment: 'justify',
        columns: mappingHeader(),
      },

      '\n\n',
      {
        columns: [
          {
            text: 'Dear, \n Customer \n - \n Booking Date: 15 Juli 2024',
            bold: true,
          },
        ],
      },

      "\n\n Thank you for choosing us! We're absolutely thrilled and can't wait to embark on this exiting day with you. See you soon for fun times ahead!\n\n",
      {
        layout: {
          defaultBorder: false,
          hLineWidth: function (i, node) {
            return 1;
          },
          vLineWidth: function (i, node) {
            return 1;
          },
          hLineColor: function (i, node) {
            return i === 0 ? '#000000' : '#eaeaea';
          },
          vLineColor: function (i, node) {
            return '#eaeaea';
          },
          hLineStyle: function (i, node) {
            // if (i === 0 || i === node.table.body.length) {
            return null;
            //}
          },
          // vLineStyle: function (i, node) { return {dash: { length: 10, space: 4 }}; },
          paddingLeft: function (i, node) {
            return 10;
          },
          paddingRight: function (i, node) {
            return 10;
          },
          paddingTop: function (i, node) {
            return 3;
          },
          paddingBottom: function (i, node) {
            return 3;
          },
          fillColor: function (rowIndex, node, columnIndex) {
            return '#fff';
          },
        },
        table: {
          widths: ['*', 'auto', 'auto', 100],
          body: mappingItem(transaction),
        },
      },
      '\n',
      {
        layout: {
          defaultBorder: false,
          hLineWidth: function (i, node) {
            return 1;
          },
          vLineWidth: function (i, node) {
            return 1;
          },
          hLineColor: function (i, node) {
            return i === 3 ? '#000000' : '#eaeaea';
          },
          vLineColor: function (i, node) {
            return '#eaeaea';
          },
          hLineStyle: function (i, node) {
            // if (i === 0 || i === node.table.body.length) {
            return null;
            //}
          },
          // vLineStyle: function (i, node) { return {dash: { length: 10, space: 4 }}; },
          paddingLeft: function (i, node) {
            return 10;
          },
          paddingRight: function (i, node) {
            return 10;
          },
          paddingTop: function (i, node) {
            return 3;
          },
          paddingBottom: function (i, node) {
            return i === 2 ? 20 : 3;
          },
          fillColor: function (rowIndex, node, columnIndex) {
            return '#fff';
          },
        },
        table: {
          headerRows: 1,
          widths: ['*', 100],
          body: mappingPrice(transaction),
        },
      },
      '\n',
      'Just a friendly reminder that your invoice will expire on . \n',
      'To keep things running smoothly, please ensure your payment is compoleted before this data. \n\n',
      'For your convenience, here is a list of our account details :',

      "\n\n Once you've made the payment, please kindly email or send the proof of payment so we can proceed with your booking promptly. \n",
      'If you have any questions or need assistance, feel free to reach out to our support team at 0821-3242-4523 \n\n\n\n',

      {
        layout: {
          defaultBorder: false,
          hLineWidth: function (i, node) {
            return 1;
          },
          vLineWidth: function (i, node) {
            return 1;
          },
          hLineColor: function (i, node) {
            return i === 0 ? '#000000' : '#eaeaea';
          },
          vLineColor: function (i, node) {
            return '#eaeaea';
          },
          hLineStyle: function (i, node) {
            // if (i === 0 || i === node.table.body.length) {
            return null;
            //}
          },
          // vLineStyle: function (i, node) { return {dash: { length: 10, space: 4 }}; },
          paddingLeft: function (i, node) {
            return 10;
          },
          paddingRight: function (i, node) {
            return 10;
          },
          paddingTop: function (i, node) {
            return 20;
          },
          paddingBottom: function (i, node) {
            return 3;
          },
          fillColor: function (rowIndex, node, columnIndex) {
            return '#fff';
          },
        },
        table: {
          widths: ['*', 200],
          body: mappingFooter(),
        },
      },
    ],
    styles: {
      notesTitle: {
        fontSize: 10,
        bold: true,
        margin: [0, 50, 0, 3],
      },
      notesText: {
        fontSize: 10,
      },
      tableExample: {
        margin: [0, 5, 0, 15],
        headerRows: 1,
        widths: ['*', 100],
      },
      tableHeader: {
        bold: true,
        fontSize: 13,
        color: 'black',
      },
    },
    defaultStyle: {
      columnGap: 20,
    },
  };
}
