import { BaseCustomManager } from 'src/core/modules/domain/usecase/managers/base-custom.manager';
import { TransactionEntity } from '../../entities/transaction.entity';
import { EventTopics } from 'src/core/strings/constants/interface.constants';
import { TransactionModel } from '../../../data/models/transaction.model';
import { PdfMaker } from 'src/modules/configuration/export/domain/helpers/pdf-make.helper';

export class InvoiceTransactionManager extends BaseCustomManager<TransactionEntity> {
  get entityTarget(): any {
    return TransactionModel;
  }

  getResult() {
    return [];
  }

  get eventTopics(): EventTopics[] {
    return;
  }

  validateProcess(): Promise<void> {
    return;
  }

  beforeProcess(): Promise<void> {
    return;
  }

  async process(): Promise<void> {
    const transaction = await this.dataService.getOneByOptions({
      where: {
        id: this.data.id,
      },
      relations: ['items'],
    });

    PdfMaker(transaction);
    return;
  }

  afterProcess(): Promise<void> {
    return;
  }
}
